=== debian/changelog ===
wildmidi (0.4.6-1) unstable; urgency=medium

  * Team Upload

  [ Bret Curtis ]
  * New upstream release.
  * Update control and metadata (Closes: #1082522)
  * Added cmake and .pc files (Closes: #916631)
  * Added hardening and build-depends-package from lintian

  [ Patrice Duroux ]
  * Updated watchfile (Closes: #1036913)

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.5.0, no changes needed.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use secure URI in Homepage field.
  * Update watch file format version to 4.
  * Apply multi-arch hints.
    + libwildmidi-dev: Add Multi-Arch: same.

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Aug 2025 18:09:51 +0200
