=== debian/watch ===
version=4
opts="searchmode=plain" \
    https://api.github.com/repos/Mindwerks/@PACKAGE@/releases?per_page=100 \
    https://github.com/Mindwerks/@PACKAGE@/releases/download/[^/]+/@PACKAGE@-(\d[\.\d]*)@ARCHIVE_EXT@
